#!/usr/local/bin/perl

binmode STDOUT;

require "sproxy.ini";

%data = &ParseInput();

$cmd = $data{'cmd'};

if ( (($cmd eq '') && ($data{'doc'} eq '')) || ($cmd eq 'init') || ($cmd eq 'sp_func') || ($cmd eq 'show') || ($cmd eq 'opts') || ($cmd eq 'unload') || ($cmd eq 'acheck') || ($cmd eq 'rdrct') || ($cmd eq 'chk_fr') ) {
##############################################################################
	$data{'spch_js_path'}	= $spch_js_path;
	$data{'sproxy_url'}	= $sproxy_url;
	$data{'def_lang'}	= $def_lang;
	$data{'def_enabled'}	= $def_enabled;
	$data{'def_timeout'}	= $def_timeout;
	$data{'opt_bg_cl'}	= $opt_bg_cl;
	$data{'auto_hide'}	= $auto_hide;
	$data{'main_server'}	= $main_server;
	$data{'second_servers'}	= $second_servers;
	$data{'exptime'}	= $exptime;

	$data{'doc_process'}	= 'script/ssrv.cgi';
	$data{'spell_script'}	= "http://$data{'main_server'}$data{'doc_process'}";
	$data{'achk_ver'}	= 'sproxy.(Perl) v.0.9.22 (c) SpellChecker.Net 2000';

	@achk_path		= split(/(\/)|(\\)/,$0);
	$data{'achk_file'}	= $achk_path[$#achk_path];

	$data{'self_name'}	= $data{'sproxy_url'};

	@pararr			= split(/:/, get_cookie('acpars'));
	$data{'lang'}		= $pararr[0] || $data{'def_lang'};
	$data{'timeout'}	= $pararr[1] || $data{'def_timeout'};
	$data{'enabled'}	= $pararr[2] || $data{'def_enabled'};

	$data{'text'}		=~ s/&/&amp;/g;
	$data{'text'}		=~ s/\"/&quot;/g;
	$data{'text'}		=~ s/\r/&#13;/g;
	$data{'text'}		=~ s/\n/&#10;/g;
	$data{'text'}		=~ s/\t/&#9;/g;

	$data{'ch_f_name'}	= "chfr_x_1";
	$data{'sp_f_name'}	= "spfr_x_2";
	$data{'op_w_name'}	= "opwd_x_3";
##############################################################################
	$data{'framesetbeg'} 	= '<frameset onload="javascript: doLoad();" onunload="javascript: doUnload();" cols="0,0" frameborder="No" framespacing=0 border=0 bgcolor=#FFFFFF>';
	$data{'framesetend'}	= '</frameset>';
	$data{'framebeg'}	= '<frame name';
	$data{'frameend'}	= 'marginwidth="0" marginheight="0" noresize scrolling="no" frameborder="no" framespacing=0>';
	$data{'frameref'}	= 'frames';
##############################################################################
	$data{'msrvr'}		= $data{'main_server'};
	$data{'scndsrvr'}	= $data{'second_servers'};

	if ($data{'cmd'} eq 'init') {
		$data{'cur_mainsrv'} = get_cookie('cursrv') || $data{'main_server'};

		if ($data{'second_servers'} eq '') {
			if ($data{'cur_mainsrv'} ne $data{'main_server'}) {
				$data{'second_servers'} = $data{'main_server'};
			}
		} else {
			$data{'second_servers'} = $data{'main_server'} . ';' . $data{'second_servers'};
		}

		$data{'second_servers'}	=~ s/$data{'cur_mainsrv'}//gi;
		$data{'second_servers'}	=~ s/(;+)/;/g;
		$data{'second_servers'}	=~ s/^;//;
		$data{'second_servers'}	=~ s/;$//;

		$data{'main_server'}	= $data{'cur_mainsrv'};
	}
##############################################################################
}
##############################################################################
$data{'def_ssrv_host'}	= 'www.spellchecker.net';
$data{'def_ssrv_port'}	= 80;
$data{'def_ssrv_path'}	= '/spellcheck/script/ssrv.cgi';

$DOC_BLANK		= '/spellcheck/lf/blank.html';
$DOC_BLANKFORM		= '/spellcheck/lf/blankform.html';

$data{'ssrv_host'} = $data{'ssrv_host'} || $data{'def_ssrv_host'};
$data{'ssrv_port'} = $data{'ssrv_port'} || $data{'def_ssrv_port'};
$data{'ssrv_path'} = $data{'ssrv_path'} || $data{'def_ssrv_path'};
##############################################################################
if ($data{'debug'} ne '') {
	&printHeader();
}

$ParseTmplt = 1;

if ($cmd eq 'init')
{	$template	= 'init.tmpl';		}
elsif ($cmd eq 'sp_func')
{	$template	= 'dospell.tmpl'	}
elsif ($cmd eq 'show')
{	$template	= 'show.tmpl';		}
elsif ($cmd eq 'opts')
{	$template	= 'opts.tmpl';		}
elsif ($cmd eq 'unload')
{	$template	= 'unload.tmpl';	}
elsif ($cmd eq 'acheck')
{	&DoCheck();				} 
elsif ($cmd eq 'rdrct')
{	$template	= 'result.tmpl';	}
elsif ($cmd eq 'chk_fr')
{	$template	= 'result.tmpl';	}
elsif ( ($cmd ne '') || ($data{'doc'} ne '') )
{	&DoCheck();				}
else
{	if ($data{'result'} ne '')
	{	$template	= 'result.tmpl';}
	else
	{	
		$template	= "<html><head></head><body><b>$data{'achk_ver'}</b><br>SCRIPT FILENAME: $data{'achk_file'}</body></html>";
		$ParseTmplt	= 0;
	}
}
##############################################################################
if ($cmd ne 'acheck') {
	&printHeader();
}
if ($ParseTmplt == 1) {
	&PrintTemplate($template, %data);
} else {
	print $template;
}
##############################################################################
sub printHeader() {
	print "Content-type: text/html; charset=UTF-8\n";
	print "Expires: Tue Jan 1 00:00:00 1980 GMT;\n";
	print "Pragma: no-cache;\n";
	print "Cache-Control: no-cache;\n\n";
}
##############################################################################
# get_cookie()
#	Gets cookie by name
##############################################################################
sub get_cookie() {
	my ($name) = @_;

	$name=&cookie_scrub($name);
	my $temp=$ENV{'HTTP_COOKIE'};
	@pairs=split(/\; /,$temp);
	foreach my $sets (@pairs) {
		my ($key,$value)=split(/=/,$sets);
		$clist{$key} = $value;
	}
	my $retval=$clist{$name};

	return $retval;
}

sub cookie_scrub() {
	my($retval) = @_;

	$retval=~s/\;//;
	$retval=~s/\=//;

	return $retval;
}
##############################################################################
# DoCheck()
#	Checks entered text and server availability.
#	It is used by the ping routine.
##############################################################################
sub DoCheck() {
	$err_no			= 'No errors.';
	$err_nohost		= 'Host not found.';
	$err_server_invalid	= 'Invalid server.';
	$err_socket		= 'Socket creation error.';
	$err_connect		= 'Connection failed.';

	my $get = '';

	if ($cmd eq 'acheck') {
		$code = ' 302 ';

		$get = "customerid=$data{'customerid'}&lang=$data{'lang'}&text=$data{'text'}&cmd=check&trg_url=$data{'trg_url'}&frameid=$data{'frameid'}";
	} else {
		$code = ' 200 ';

		if ($data{'doc'} ne '') {
			if ($data{'doc'} eq 'blank') 
				{ $data{'ssrv_path'} = $DOC_BLANK; }
			elsif ($data{'doc'} eq 'blankform')
				{ $data{'ssrv_path'} = $DOC_BLANKFORM; }
		} else {
			foreach $f (keys %data) {
				if ( ($f ne 'def_ssrv_host') && ($f ne 'def_ssrv_port') && ($f ne 'def_ssrv_path') && ($f ne 'ssrv_host') && ($f ne 'ssrv_port') && ($f ne 'ssrv_path') ) {
					if ($get ne '') {$get .= '&'}
					$get .= $f . '=' . $data{$f};
				}
			}
		}

	}

	$result = &CheckServer($data{'ssrv_host'}, $data{'ssrv_port'}, $data{'ssrv_path'}, $get, $code);

	if ($data{'debug'} ne '') {
		print '</pre><hr>ERROR_CODE:'.$result; 
		exit();
	}

	if ($cmd ne 'acheck') { exit(); }

	if ($result ne $err_no) {
		&printHeader();
		&PrintTemplate('check.tmpl', %data);
	}
	exit();
}

sub CheckServer() {
	($host, $port, $ssrv, $get, $code) = @_;
	use Socket;

	if ($data{'debug'} ne '') {
		print '<html><body><pre>';

		if ($get eq '') {
			print "GET";
		} else {
			print "POST";
		}
		print " http://$host:$port/$ssrv HTTP/1.0\n<br>";
		print "Accept: */*\n<br>";
		if ($cmd eq 'acheck') {
			print "User-Agent: Auto SpellCheck. Pinger\n<br>";
		} else {
			print "User-Agent: $ENV{'HTTP_USER_AGENT'}\n<br>";
		}
		if ($get ne '') {
			print "Content-Length: ".length($get)."\n<br>";
		}
		print "Pragma: no-cache\n<br>";
		print "Cookie: $ENV{'HTTP_COOKIE'}\n<br>";
		print "\n<br>";
		if ($get ne '') {
			print "$get\n<br>";
			print "\n<br>";
		}
		print '</pre><hr>';
		print '<pre>';
	}
	$iaddr=inet_aton($host) || { return $err_nohost };

	$hostaddr=sockaddr_in($port, $iaddr);

	$proto = getprotobyname('tcp');

	if ( !defined($hostaddr) ) { return $err_server_invalid }

	if ( !socket(S, PF_INET, SOCK_STREAM, $proto) ) { return $err_socket }

	if ( !connect(S, $hostaddr) ) { close S; return $err_connect }

	my($oldfh) = select(S); $| = 1; select($oldfh);

	if ($get eq '') {
		print S "GET";
	} else {
		print S "POST";
	}
	print S " http://$host:$port$ssrv HTTP/1.0\n";
	print S "Accept: */*\n";
	if ($cmd eq 'acheck') {
		print S "User-Agent: Auto SpellCheck. Pinger\n";
	} else {
		print S "User-Agent: $ENV{'HTTP_USER_AGENT'}\n";
	}
	if ($get ne '') {
		print S "Content-Length: ".length($get)."\n";
	}
	print S "Pragma: no-cache\n";
	print S "Cookie: $ENV{'HTTP_COOKIE'}\n";
	print S "\n";
	if ($get ne '') {
		print S "$get\n";
		print S "\n";
	}

	$http_header = <S>;
	if ($data{'debug'} ne '') { print $http_header; }
	
	while (<S>) {
		if ($data{'debug'} ne '') { s/</&lt;/g; }
		print $_;
	}

	s/\n//g;
	s/\r//g;

	if ( index($http_header, $code) == -1 ) {
		close S;
		return substr($http_header,9,3);
	}
	close S;
	return $err_no;
}
#########################################################################
# ParseInput()
#    Parses the input and returns all parameters as a hash.
#    Deletes all blackslashes and single quotes from the security reasons
#########################################################################
sub ParseInput() {
	(*fval) = @_ if @_ ;

	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN,$buf,$ENV{'CONTENT_LENGTH'});
	}
	else {
		$buf=$ENV{'QUERY_STRING'};
	}
	if ($buf eq "") {
            return 0;
		}
	else {
 		@fval=split(/&/,$buf);
		foreach $i (0 .. $#fval){
			($name,$val)=split (/=/,$fval[$i],2);
			$val=~tr/+/ /;
			$val=~ s/%(..)/pack("c",hex($1))/ge;
			$val=~ s/\\//g;
			$val=~ s/\`//g;
			$name=~tr/+/ /;
			$name=~ s/%(..)/pack("c",hex($1))/ge;
			$name=~ s/\\//g;
			$name=~ s/\`//g;

			if (!defined($field{$name})) {
				$field{$name}=$val;
			}
			else {
				$field{$name} .= ",$val";
			}
	   }
	}
return %field;
}
#########################################################################
# PrintError
#    Prints error message
#########################################################################
sub PrintError() {
	($msg) = @_;
	print "$msg";
	exit();
}
#########################################################################
# PrintTemplate($template, %data)
#    Prints the $template page replacing <#something#> constructions with 
#    parameters from %data
#########################################################################
sub PrintTemplate() {
	($template, %data) = @_;
	if (!$template) {&PrintError("No template given.");}
	open (TPL, $template) or &PrintError("Cannot open template '$template'.");
	while (<TPL>) {
		s/<#(\w+)#>/$data{$1}/g;
		print;
	}
	close TPL or &PrintError("Cannot close template.");
}
